/*  libbadpenguin -- generic library for Bad Penguin development
 *
 *  Copyright (C) 1996 Antonio Gallo
 *  agx@linux.it
 *  
 *  Newer versions should be on www.badpenguin.org
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// Extract the basename of a file
char *dirbase(char *s1) {
  char *s2 = NULL;
  int l;
  if( s1 == NULL ) {
    fprintf(stderr, "dirbase: NULL pointer detected!");
    return 0;
  }
  l = strlen(s1);
  if ( s1[l-1] == '/' ) {
    s1[l-1] = 0;
    l--;
  }
  while ( (l>=0) && (s1[l]!='/') ) l--;
  if (l>=0) {
    s2 = (char*)malloc( sizeof(char) * ( strlen(s1) - l + 2 ) );
    strcpy( s2, s1+l+1 );
  } else {
    s2 = (char*) strdup(s1);
  }    
  return s2;
}

